Name:           perl
Version:        5.8.8
Release:        1

Summary:        The Perl programming language
Group:          Development/Languages
License:        Artistic or GPL
Url:            http://www.perl.org/

# Source0:        http://www.cpan.org/authors/id/N/NW/NWCLARK/%{name}-%{version}.tar.gz
# Version 5.8.8 with all upstream patches up to #34468
# see http://dev.perl.org/perl5/source.html for details
Source0:        %{name}-%{version}-maint-34467.tar.bz2

Patch0:	%{name}-%{version}-aix.patch
# not required anymore
# Patch1:       %{name}-%{version}-gcc-4.2.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires:  gcc >= 4.2.3, patch, gdbm-devel >= 1.8.3

Requires:       libgcc >= 4.2.3, gdbm >= 1.8.3

%define perlmodcompat 5.8.7 5.8.6 5.8.5
Provides: perl(:MODULE_COMPAT_5.8.5)
Provides: perl(:MODULE_COMPAT_5.8.6)
Provides: perl(:MODULE_COMPAT_5.8.7)
Provides: perl(:MODULE_COMPAT_5.8.8)

# By definition of 'do' (see 'man perlfunc') this package provides all
# versions of perl previous to it.
Provides: %{name} <= %{version}

# These provides are needed by the perl pkg itself with auto-generated perl.req
Provides: perl(VMS::Filespec)
Provides: perl(VMS::Stdio)

Provides: perl(abbrev.pl)
Provides: perl(assert.pl)
Provides: perl(bigfloat.pl)
Provides: perl(bigint.pl)
Provides: perl(bigrat.pl)
Provides: perl(bytes_heavy.pl)
Provides: perl(cacheout.pl)
Provides: perl(complete.pl)
Provides: perl(ctime.pl)
Provides: perl(dotsh.pl)
Provides: perl(dumpvar.pl)
Provides: perl(exceptions.pl)
Provides: perl(fastcwd.pl)
Provides: perl(find.pl)
Provides: perl(finddepth.pl)
Provides: perl(flush.pl)
Provides: perl(ftp.pl)
Provides: perl(getcwd.pl)
Provides: perl(getopt.pl)
Provides: perl(getopts.pl)
Provides: perl(hostname.pl)
Provides: perl(importenv.pl)
Provides: perl(look.pl)
Provides: perl(newgetopt.pl)
Provides: perl(open2.pl)
Provides: perl(open3.pl)
Provides: perl(perl5db.pl)
Provides: perl(pwd.pl)
Provides: perl(shellwords.pl)
Provides: perl(stat.pl)
Provides: perl(syslog.pl)
Provides: perl(tainted.pl)
Provides: perl(termcap.pl)
Provides: perl(timelocal.pl)
Provides: perl(utf8_heavy.pl)
Provides: perl(validate.pl)

Provides: perl(Carp::Heavy)

# These modules appear to be missing or break assumptions made by the
# dependency analysis tools.  Typical problems include refering to
# CGI::Apache as Apache and having no package line in CPAN::Nox.pm. I
# hope that the perl people fix these to work with our dependency
# engine or give us better dependency tools.
#
# Provides: perl(Apache)
# Provides: perl(ExtUtils::MM_Mac)
# Provides: perl(ExtUtils::XSSymSet)
# Provides: perl(LWP::UserAgent)
# Provides: perl(URI::URL)

# Conflicts: perl-NDBM_File <= 1:1.75-34.99.6

Obsoletes: perl-Digest-MD5
Obsoletes: perl-MIME-Base64
Obsoletes: perl-libnet
Obsoletes: perl-Storable
Obsoletes: perl-CGI
Obsoletes: perl-CPAN
Obsoletes: perl-DB_File
Obsoletes: perl-Filter
Obsoletes: perl-Filter-Simple
Obsoletes: perl-Time-HiRes
Obsoletes: perl-Test-Builder-Tester

%description
Perl is a high-level programming language with roots in C, sed, awk
and shell scripting.  Perl is good at handling processes and files,
and is especially good at handling text.  Perl's hallmarks are
practicality and efficiency.  While it is used to do a lot of
different things, Perl's most common applications are system
administration utilities and web programming.  A large proportion of
the CGI scripts on the web are written in Perl.  You need the perl
package installed on your system so that your system can handle Perl
scripts.

Install this package if you want to program in Perl or enable your
system to handle Perl scripts.

Perl is available in 32-bit and 64-bit and the 64-bit binaries have
been renamed to "<name>_64bit".


%package suidperl
Summary:        Suidperl, for use with setuid perl scripts
Group:          Development/Languages
License:        GPL or Artistic
Requires:       %{name} = %{version}-%{release}

%description suidperl
Suidperl is a setuid binary copy of perl that allows for (hopefully)
more secure running of setuid perl scripts.


%prep
export PATH=/opt/freeware/bin:$PATH
%setup -q
%patch0

mkdir -p ../64bit
cp -r * ../64bit/
mv ../64bit .


%build

dobuild()
{
  /bin/sh Configure \
    -des \
    -Dversion=%{version} \
    -Dmyhostname=aix51 \
    -Dperladmin=michael@perzl.org \
    -Dcc="$1" \
    -Dccflags='-D_ALL_SOURCE -D_ANSI_C_SOURCE -D_POSIX_SOURCE -DUSE_NATIVE_DLOPEN -DNEED_PTHREAD_INIT -I/opt/freeware/include -D_LARGE_FILES' \
    -Dccflags_uselargefiles='-D_LARGE_FILES' \
    -Doptimize='-O' \
    -Dcf_by='Michael Perzl' \
    -Dcf_email='michael@perzl.org' \
    -Dalignbytes=8 \
    -Dld='ld' \
    -Dldflags="$2" \
    -Dso=a \
    -Duseshrplib=true \
    -Dshrpldflags='-Wl,-H512 -Wl,-T512 -Wl,-bhalt:4 -Wl,-bM:SRE -Wl,-bE:perl.exp' \
    -Dlddlflags='-Wl,-bhalt:4 -Wl,-bM:SRE -Wl,-bI:$(PERL_INC)/perl.exp -Wl,-bE:$(BASEEXT).exp -Wl,-bnoentry -lpthreads' \
    -Dlibperl=libperl.a \
    -Dinstallprefix=%{_prefix} \
    -Dprefix=%{_prefix} \
    -Darchname=%{_arch} \
    -Dvendorprefix=%{_prefix} \
    -Dsiteprefix=%{_prefix} \
    -Duseshrplib \
    -Dusethreads \
    -Duseithreads \
    -Duselargefiles \
    -Dd_dosuid \
    -Dd_semctl_semun \
    -Di_syslog \
    -Dman3ext=3 \
    -Duseperlio \
    -Dinstallusrbinperl=n \
    -Ubincompat5005 \
    -Uversiononly \
    -Dpager='/usr/bin/more' \
    -Dinc_version_list='%{perlmodcompat}' \
    -Dscriptdir='%{_bindir}'

  make %{?_smp_mflags}
}

dobuild 'gcc'         '-Wl,-brtl -Wl,-b32 -Wl,-bmaxdata:0x80000000'

cd 64bit
dobuild 'gcc -maix64' '-Wl,-brtl -Wl,-b64'


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
make DESTDIR=${RPM_BUILD_ROOT} install
for f in a2p perl perl%{version} sperl%{version} suidperl ; do
    mv ${RPM_BUILD_ROOT}%{_bindir}/${f} ${RPM_BUILD_ROOT}%{_bindir}/${f}_64bit
done

cd ..
make DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

chmod -R u+w ${RPM_BUILD_ROOT}/*

# Compress Changes* to save space
gzip --best Changes*

# rename ${RPM_BUILD_ROOT}%{_mandir}/man3/threads.3 as it might conflict with
# man3/threads.3 from openssl-doc
cd ${RPM_BUILD_ROOT}%{_mandir}/man3
mv -f threads.3 threads.3pm


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc Artistic AUTHORS Changes* Copying README
%{_mandir}/man1/*.1*
%{_mandir}/man3/*.3*
%{_bindir}/[a-p,x]*
%{_bindir}/s2p
%{_bindir}/splain
%{_libdir}/perl5


%files suidperl
%defattr(-,root,system,-)
%{_bindir}/sperl%{version}*
%{_bindir}/suidperl*


%changelog
* Wed Oct 08 2008 Michael Perzl <michael@perzl.org> - 5.8.8-1
- first version for AIX V5.1 and higher, intentionally built with GCC
